import java.util.*;

public class GenericDemo {

    /** Demonstration of simple generics with Vector and HashSet */
    public static void main(String[] args) {
        demoNonGenericVector();

        demoNonGenericHashSet();

        demoStringHashSet();
    }

    /** Demo non-generic Vector */
    public static void demoNonGenericVector() {
        Vector v= new Vector();
        v.add("abc");
        v.add(3);         // 3 will be autoboxed. RHS equivalent to new Integer(3);

        System.out.println("Vector v: " + v);
        Object v0= v.get(0);

        // Uncomment following line to see that casting is necessary.
        //String vs= v.get(0);

        // Illustrate foreach loop over a Vector
        System.out.println("Elements of Vector v:");
        for (Object c: v) {
            System.out.println(c);
        }
    }

    /** Demo String Vector */
    public static void demoStringVector() {
        Vector<String> v= new Vector<String>();
        v.add("Obama");
        v.add("abc");

        System.out.println("Vector v: " + v);
        String v0= v.get(0);       // no casting to String is necessary

        // Uncomment following line to see that only Strings go in v.
        // v.add(new Integer(3));
    }

    /** Demo non-generic HashSet */
    public static void demoNonGenericHashSet() {
        System.out.println("\nDemo non-generic HashSet");
        HashSet s= new HashSet();
        s.add("abc");
        s.add(3);         // 3 will be autoboxed. RHS equivalent to new Integer(3);
        s.add(2);         // 2 will be autoboxed

        System.out.println("set s. No duplicates, elements not given in order added: " + s);

        // Illustrate foreach loop over a HashSet
        System.out.println("Elements of set s, not given in order added:");
        for (Object c: s) {
            System.out.println(c);
        }
    }

    /** Demo String HashSet */
    public static void demoStringHashSet() {
        System.out.println("\nDemo generic String HashSet");
        HashSet<String> s= new HashSet<String>();
        s.add("abc");
        s.add("abc");
        s.add("Obama");

        System.out.println("HashSet s: " + s);       

        // Uncomment following line to see that only Strings can be added to s
        // s.add(new Integer(3));
    }





}
